/********** Fichiers d'inclusion **************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>

#include <netinet/tcp.h>
#include <netdb.h>
#include <arpa/nameser.h>
#include <resolv.h>

#include "lib_SMTP.h"
#include "../Communication/libcom.h"


/********** Fonctions d'envoi des mail au serveur de destination **********/

void envoi_mail(Client_t* client)
{
	FILE * mxip = fopen("mxrecord.txt", "r");
	if(mxip == NULL)
	{
        perror("mxrecord.txt.fdopen");
        exit(EXIT_FAILURE);
    
	}
	char ipserv[MAX_LIGNE];
	fgets(ipserv,MAX_LIGNE,mxip);
	
	printf("adresse du serveur de destination: %s", ipserv);
	 
	int s = connexionServeur(ipserv,"465");
	//int s = connexionServeur(client->domaine,"25");
	if(s<0)
		{
			fprintf(stderr,"Erreur de connexion au serveur\n");
			exit(EXIT_FAILURE);
		}
}









/********** Fonctions de gestion des MX **********/

//////////
static int compare (const void *a, const void *b)
{  
    if (((mx_t *)a)->priority < ((mx_t *)b)->priority) 
    {
        return -1;
	}
	else if (((mx_t *)a)->priority > ((mx_t *)b)->priority)
	{
        return 1;
    } 
	else
	{
		return 0;
    }
}

//////////
static void aff (struct struct_mx *mx, size_t n)
{
   size_t i; 
   for (i = 0; i < n; i++)
   {
      printf ("---> %d     %s \n\n", mx[i].priority,mx[i].servername);
   }
}

////////////////////
void nomVersAdresse (Client_t* client)
{
	unsigned char Buffer[8000]   = {0};
	const unsigned char *pResult = NULL;
	struct struct_mx mx[16];
	struct __res_state ResState  = {0};
	ns_msg nsMsg = {0};
	ns_rr  rr;

	int  type     = 0;
	int  ret      = 0;
	int  size     = 0;
	int  count    = 0;
	int  i        = 0;
	int  res_init = 0;

	ret = res_ninit (&ResState);

	if (ret)
	{
		printf ("error initializing resolver\n");
		goto close;
	}
	res_init = 1;

	memset(Buffer, 0, sizeof (Buffer));

	size = res_nquery (&ResState, client->domaine, C_IN, T_MX, Buffer, sizeof(Buffer)-1);

	if (0 == size)
		goto close;

	ret = ns_initparse (Buffer, size, &nsMsg);

	if (ret)
		goto close;

	count = ns_msg_count (nsMsg, ns_s_an);

	for (i=0; i< count;i++)
	{
		ret = ns_parserr (&nsMsg, ns_s_an, i , &rr);

		if (ret)
			goto close;

		type = ns_rr_type (rr);
		
		if (ns_t_mx == type)
		{
			pResult = ns_rr_rdata (rr);
			NS_GET16(mx[i].priority,pResult);
			dn_expand(ns_msg_base(nsMsg),ns_msg_end(nsMsg),pResult,mx[i].servername,MAX_SERVER_NAME);
			//printf("%d %s\n",mx[i].priority,mx[i].servername);
	    }
	}
	
	/* Trier les serveurs de destination dans l'ordre croissant de leur priorité */
    qsort (mx, count, sizeof (mx_t), compare);
	/* Afficher les mx */
    aff (mx, count);
	 
	close:
		if (res_init)
			res_nclose (&ResState);
	
	/* Résoudre l'IP du serveur de destination avec la commande "host" */
	char command[MAX_LIGNE];
	strcpy(command,"host ");
	strcat(command,mx[0].servername);
	/* Stocker l'IP du serveur de destination dans un fichier "mxrecord.txt" */
	strcat(command, " | cut -f4 -d ' ' >mxrecord.txt");
	system(command);
}

////////////////////
void trouve_mx(Client_t* client,FILE* dialogue){
    int i=0;
    int flag_fin=0;
    int flag_arobase=0;

    while (flag_fin==0)
    {
        if (client->rcpt[i]!='@' && flag_arobase ==0)
        {
            i++;
        }
        else
        {
            flag_arobase =1;
            i++;
            for (int j=0; j<100; j++)
            {
                if (client->rcpt[i] != '\0')
                {
                    client->domaine[j]=client->rcpt[i];
                    //fprintf(dialogue,"domaine intermediaire:%s\r\n",client->domaine);
                    i++;
                }
                else
                {
                    //fprintf(dialogue,"domaine final:%s\r\n",client->domaine);
                    flag_fin=1;
                    break;
                }
            }
        }
    }
}






/******************** Fonctions de gestion SMTP ********************/

//////////
void gestion_HELO(char *ligne,char *code,Client_t* client,FILE* dialogue)
{
	sscanf(ligne,"%4s %s",code,client->helo);
	fprintf(dialogue,"250 TristanJerome ZABETH11 (ID:%s) \r\n",client->helo);
}

//////////
void gestion_MAIL(char *ligne,char *code,Client_t* client,FILE* dialogue)
{
	sscanf(ligne,"%4s %s",code,client->mail);
	client->mail[strlen(client->mail)+1]='\0';
	fprintf(dialogue,"250 MAIL FROM: %s\r\n",client->mail);
}

//////////
void gestion_RCPT(char *ligne,char *code,Client_t* client,FILE* dialogue)
{
	sscanf(ligne,"%4s %s",code,client->rcpt);
	client->rcpt[strlen(client->rcpt)+1]='\0';
	fprintf(dialogue,"250 RCPT TO: %s\r\n",client->rcpt);
}

//////////
void gestion_QUIT(FILE* dialogue)
{
    fprintf(dialogue,"221 Bye\r\n");
}

//////////
void gestion_DATA(char *ligne, char *code, Client_t* client, FILE* dialogue)
{
   	client->taille_max=MAX_ALLOC;
	client->taille_body=0;
	client->body = malloc(client->taille_max);
	client->body[0]='\0';
	
	while(fgets(ligne,MAX_LIGNE,dialogue)!=NULL)
	{
		char verif[MAX_LIGNE];
		sscanf(ligne, "%s", verif);
		if (strcmp(verif,".")==0)
		{
			fprintf(dialogue,"250 DATA\r\n");
			printf("\n\r%s \n\r",client->body);
			break;
		}
		else if ((client->taille_max-client->taille_body)<=strlen(ligne))
		{		
			client->taille_max += MAX_ALLOC;
			client->body=realloc(client->body,client->taille_max);
		}
		strcat(client->body,ligne);
		client->taille_body += strlen(ligne);
	}
}

////////////////////
void gestionSmtp(void * arg)
{
	int s = *(int *) arg; 
	
	/* Obtient une structure de fichier */
	Client_t client;
	
	FILE *dialogue=fdopen(s,"a+");
	if(dialogue==NULL){ perror("gestionClient.fdopen"); exit(EXIT_FAILURE); }
	else {fprintf(dialogue,"220 TristanJerome ESMTP\n");}
	
	int flag_helo;

	char code[MAX_CODE];
	char ligne[MAX_LIGNE];

	while(fgets(ligne,MAX_LIGNE,dialogue)!=NULL)
	{
		sscanf(ligne,"%4s",code);
		if (strcmp(code,"HELO")==0)
		{	
			flag_helo=1;
			gestion_HELO(ligne,code,&client,dialogue);
		}

		else if(strcmp(code,"MAIL")==0)
		{
			if(flag_helo == 1)
			{
				gestion_MAIL(ligne,code,&client,dialogue);
			}
			else {fprintf(dialogue,"503 Les personnes polies s'annoncent\r\n");}
		}
	
		else if(strcmp(code,"RCPT")==0)
		{	
			if (flag_helo==1)
			{
				gestion_RCPT(ligne,code,&client,dialogue);
			}
			else {fprintf(dialogue,"503 Les personnes polies s'annoncent\r\n");}
		}

		else if(strcmp(code,"DATA")==0)
		{
			if (flag_helo==1)
			{
				fprintf(dialogue,"354 \n\r");
				gestion_DATA(ligne,code,&client,dialogue);
			}
			else {fprintf(dialogue,"503 Les personnes polies s'annoncent\r\n");}
		}

		else if (strcmp(code,"QUIT")==0) 
		{
			gestion_QUIT(dialogue);
			break;
		}
		
		else fprintf(dialogue, "502 commande non reconnue par le système, contacter le programmeur\r\n");
	}
	
	/* Trouve les serveurs associés au nom de domaine du mx */
	trouve_mx(&client,dialogue);
	
	/* Résoud l'IP des serveurs IP */
	nomVersAdresse(&client);
	
	/* Envoie mail au serveur de destination*/
	envoi_mail(&client);
	
	/* Termine la connexion */
	fclose(dialogue);
}